﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Collections;

namespace GestorDatosGalindo
{
    public partial class frmGrafica : Form
    {

        private ToolStripControlHost dtTScomponent;

        public string path = "";
        private bool modificado;

        private Steema.TeeChart.Editor chartEditor;




        public frmGrafica()
        {

            inicializarGrafica();

            

           
            
                       

        }

        private void editor_CloseEditor(object sender, EventArgs e)
        {
            repasarGridSeries();
        }
        private void inicializarGrafica()
        {
            InitializeComponent();

            chartEditor = new Steema.TeeChart.Editor();
            chartEditor.Chart = chart;
            chartEditor.CloseEditor += new EventHandler(editor_CloseEditor);

           

            
            if (chart.Series.Count>0)
                chart.Series.Remove(chart.Series[0]);
           // chart.Series[0].FillSampleValues();

            //((Steema.TeeChart.Tools.ColorLine)chart.Tools[3]).DragLine += new EventHandler(event_DragLine3);
            //((Steema.TeeChart.Tools.ColorLine)chart.Tools[4]).DragLine += new EventHandler(event_DragLine3);
            

            
        }

        public frmGrafica(string path)
        {
          

        }




        private void frmGrafica_Load(object sender, EventArgs e)
        {
            lista_SelectedIndexChanged(null, null);
        }





        private void button1_Click_1(object sender, EventArgs e)
        {
            chart.Export.Template.IncludeData = false;
            chart.Export.Template.Save(@"C:\pru.tee");
        }

       

        private void seleccionarVariablesToolStripMenuItem_Click(object sender, EventArgs e)
        {
            btnNuevo_Click(null, null);
        }



        private void btnNuevo_Click(object sender, EventArgs e)
        {
            this.Cursor = Cursors.WaitCursor;

            this.Cursor = Cursors.Default;
        }


        private void button2_Click(object sender, EventArgs e)
        {
           // chartEditor.Show();
            setModificado(true);



            chartEditor.ShowModal();
//            chart.ShowEditor();


         


            //Steema.TeeChart.Editor editor = new Steema.TeeChart.Editor(chart);
            ////editor.Options = new Steema.TeeChart.Editors.ChartEditorOptions[] { Steema.TeeChart.Editors.ChartEditorOptions.Add,
            ////                                                                 Steema.TeeChart.Editors.ChartEditorOptions.Change,
            ////                                                                 Steema.TeeChart.Editors.ChartEditorOptions.Clone,
            ////                                                                 Steema.TeeChart.Editors.ChartEditorOptions.Delete,
            ////                                                                 Steema.TeeChart.Editors.ChartEditorOptions.Title};
            
            
            //editor.ShowModal(this);
        }


        private void event_DragLine3(object sender, EventArgs e)
        {
            if (lista.SelectedIndex >= 0)
            {
                DateTime fecha = DateTime.FromOADate(clRojo.Value);
                tt.SetToolTip(chart, fecha.ToString());
            }
        }

        private void event_DragLine4(object sender, EventArgs e)
        {
            if (lista.SelectedIndex >= 0)
            {
                DateTime fecha = DateTime.FromOADate(clAzul.Value);
                tt.SetToolTip(chart, fecha.ToString());
            }
        }

        private void event_EndDragLine3(object sender)
        {
            if (lista.SelectedIndex >= 0)
            {
                actualizarVerticalRoja();
                actualizarDiferenciaVerticales();
            }
        }

        private void actualizarVerticalRoja()
        {

        }
        private void event_EndDragLine4(object sender)
        {
            if (lista.SelectedIndex >= 0)
            {

                actualizarVerticalAzul();
                actualizarDiferenciaVerticales();
            }
        }

        private void actualizarVerticalAzul()
        {

        }

        private void actualizarDiferenciaVerticales()
        {
            double azul;
            double rojo;
            azul = Convert.ToDouble(anAzul.Tag);
            rojo = Convert.ToDouble(anRojo.Tag);
            DateTime fechaAzul = DateTime.FromOADate(clAzul.Value);
            DateTime fechaRojo = DateTime.FromOADate(clRojo.Value);
            string difValor = "";
            if (rojo > azul)
                difValor = (rojo - azul).ToString("0.#");
            else
                difValor = (azul - rojo).ToString("0.#");



            if (clRojo.Value > clAzul.Value)
            {
                TimeSpan dif = fechaRojo.Subtract(fechaAzul);
            }
            else
            {
                TimeSpan dif = fechaAzul.Subtract(fechaRojo);
            }

        }



        private void event_DragLine5(object sender, EventArgs e)
        {
            tt.SetToolTip(chart, Convert.ToInt32(((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value).ToString());
        }

        private void event_DragLine6(object sender, EventArgs e)
        {
            tt.SetToolTip(chart, Convert.ToInt32(((Steema.TeeChart.Tools.ColorLine)chart.Tools[6]).Value).ToString());
        }
        
        private void event_EndDragLine56(object sender)
        {
            tt.SetToolTip(chart, "");

            double? min = null;
            double? max = null;

            if (chart.Tools.Count == 6)
            {
                if (((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Tag.ToString().Equals("min"))
                    min = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value;
                else
                    max = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value;
            }
            else
            {
                if (((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value < ((Steema.TeeChart.Tools.ColorLine)chart.Tools[6]).Value)
                {
                    min = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value;
                    max = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[6]).Value;
                }
                else
                {
                    min = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[6]).Value;
                    max = ((Steema.TeeChart.Tools.ColorLine)chart.Tools[5]).Value;
                }
            }
            actualizarSerieRNominales(lista.SelectedIndex, min, max);
        }

        private void lista_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void borrarRangosNominales()
        {
            while (chart.Tools.Count > 5)
            {
                chart.Tools.RemoveAt(chart.Tools.Count - 1);
            }
            chart.Refresh();
        }

        private void dg_SelectionChanged(object sender, EventArgs e)
        {
            
        }

        public void addSerie(int tipoSerie, string tag)
        {

            switch (tipoSerie)
            {
                case 0: // lineas
                    Steema.TeeChart.Styles.Line linea = new Steema.TeeChart.Styles.Line(chart.Chart);
                    chart.Series.Add(linea);
                    break;



                default:
                    Steema.TeeChart.Styles.Points puntos = new Steema.TeeChart.Styles.Points(chart.Chart);
                    chart.Series.Add(puntos);
                    break;
            }

            chart.Series[chart.Series.Count - 1].XValues.DateTime = true;
            chart.Axes.Bottom.Labels.DateTimeFormat = "dd/MM/yyy HH:mm";

            


                refrescarSerie(chart.Series.Count - 1);

      
        }


       

        private void refrescarSerie(int numSerie)
        {
            chart.Series[numSerie].Clear();
 
            
   

                    for (int i = 0; i <200000 ; i++)
                    {
                        chart.Series[numSerie].Add(DateTime.Now.AddHours(i), i);
                    }

               
        }

 

       

   


        private void saveToolStripButton_Click(object sender, EventArgs e)
        {

        }

        private void saveAs()
        {

        }


        private void actualizarPath(string path)
        {
            this.path = path;
            this.Text = path.Substring(path.LastIndexOf(@"\") + 1, path.Length - path.LastIndexOf(@"\") - 1-4) ;
        }

       

        void setModificado(bool mod)
        {
            if (mod)
            {
                if (!modificado)
                {
                    modificado = true;
                    this.Text = this.Text + "*";
                }
            }
            else
            {
                modificado = false;
                if (this.Text.LastIndexOf("*") == this.Text.Length - 1)
                    this.Text = this.Text.Substring(0, this.Text.Length - 1);
            }
        }

        

        private void frmGrafica_FormClosing(object sender, FormClosingEventArgs e)
        {
          
        }

        	

       


        public void repasarGridSeries()
        {
            

         

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveToolStripButton_Click(null, null);
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveAs();
        }


        private void actualizarSerieRNominales(int numSerie,double? rNominalMin, double? rNominalMax)
        {
          
        }


        public void actualizarSerie(int numSerie,double? escalaMin, double? escalaMax, double? rNominalMin, double? rNominalMax, double multiplicador)
        {
          

            refrescarSerie(numSerie);

        }

        private void btnFechaIni_Click(object sender, EventArgs e)
        {
     
        }

        private void btnFechaFin_Click(object sender, EventArgs e)
        {
        
        }

 

        private double getYValue(int numSerie, double x)
        {
            for (int i = 0; i < chart.Series[numSerie].XValues.Count; i++)
            {
                if (chart.Series[numSerie].XValues[i] > x)
                {
                    if (i == 0) return chart.Series[numSerie].YValues[0];
                    else
                    {
                        if ((chart.Series[numSerie].XValues[i] - x) > x - (chart.Series[numSerie].XValues[i - 1]))
                            return chart.Series[numSerie].YValues[i - 1];
                        else
                            return chart.Series[numSerie].YValues[i];
                    }
                }
            }
            return 0;
        }

        private void chkVerticales_CheckedChanged(object sender, EventArgs e)
        {
          
        }

        private void lista_DoubleClick(object sender, EventArgs e)
        {
     
        }

  







        private void button2_Click_1(object sender, EventArgs e)
        {
            addSerie(0, "");
        }

    }


   
}
